using namespace std;

#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    double chw = has_opt("w") ? opt<double>("w") : 0.75;
    double rc = has_opt("r") ? opt<double>("r") : 0.85;
    bool make_bad = has_opt("b") && opt<bool>("b");

    int n = 1 + rnd.wnext(max_n, 3);
    n = n % 2 == 0 ? n : n - 1;

    vector<int> perm = rnd.perm(n);

    vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        colors[i] = 1 + i % 2;
    }

    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        r[i] = rnd.next() < rc; // 0 < 0 -> false
    }
    for (int i = 0; i < n; ++i) {
        if (r[i] || make_bad) {
            colors[i] = rnd.next() < chw ? 3 - colors[i] : colors[i];
        }
    }

    printf("%d %d\n", n, n / 2);
    vector<int> ncolors(n), nr(n);
    for (int i = 0; i < n; ++i) {
        ncolors[perm[i]] = colors[i];
        nr[perm[i]] = r[i];
    }

    vector <pair<int, int>> edges;
    for (int i = 0; i < n / 2; ++i) {
        int u = i * 2;
        int v = i * 2 + 1;
        if (rnd.next(0, 1)) {
            edges.emplace_back(perm[u], perm[v]);
        } else {
            edges.emplace_back(perm[v], perm[u]);
        }
    }
    shuffle(edges.begin(), edges.end());

    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", ncolors[i]);
    }
    printf("\n");
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", nr[i]);
    }
    printf("\n");

    for (const auto e : edges) {
        printf("%d %d\n", e.first + 1, e.second + 1);
    }
}

