/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

typedef vector<vector<int>> graph;

graph g;
vector<pll> dp;
ll const MOD = 1000'000'007;

ll dp_full(int v) {
    return dp[v].first + dp[v].second;
}

void dfs(int v) {
    dp[v].first = 1;
    for (int u : g[v]) {
        dfs(u);
        dp[v].first = dp[v].first * dp_full(u) % MOD;
    }

    dp[v].second = 0;
    if (g[v].size() < 2) return;

    vector<ll> r_prod(g[v].size() + 1, 1);
    for (int i = g[v].size() - 1; i > -1; i--) {
        r_prod[i] = r_prod[i + 1] * dp_full(g[v][i]) % MOD;
    }
    ll left = dp[g[v][0]].first, l_prod = 1;
    for (int i = 1; i < g[v].size(); i++) {
        ll delta = ((left * dp[g[v][i]].first) % MOD) * r_prod[i + 1] % MOD;
        dp[v].second = (dp[v].second + delta) % MOD;

        l_prod = l_prod * dp_full(g[v][i - 1]) % MOD;
        left = (left * dp_full(g[v][i]) + l_prod * dp[g[v][i]].first) % MOD;
    }
}

int main() {

    in(int, n, k)
    g.resize(n);
    for (int i = 1; i < n; i++) {
        in(int, p)
        g[--p].push_back(i);
    }

    dp.resize(n);
    dfs(0);
    cout << dp_full(0) % MOD << '\n';

}